<template>
  <div v-if="showComponent()" class="chat">
    <div class="messages">
      <ul>
        <li v-for="msg in messages" :key="msg" class="static-row" :class="{ 'me-row': isActiveUser(msg.username) }">
          <span>
            <small class="size-xs">{{ formatDate(msg.createdAt) }}</small> <br />
            <b class="c-title" v-if="!isActiveUser(msg.username)">{{ msg.username }}</b> {{ msg.content }}
          </span>
        </li>
      </ul>
    </div>
    <div class="input-container">
      <input v-model="message" placeholder="Escribe tu mensaje..." @keyup.enter="sendMessage" />
      <button @click="sendMessage">Enviar</button>
      <button @click="loadHistory">Cargar historial</button>
      <button @click="search">Buscar</button>
    </div>
  </div>
</template>

<script>
import EventBus from '../plugins/event-bus';
import { getSocket } from '../plugins/socket';

export default {
  data() {
    return {
      username: '',
      message: '',
      messages: [],
      socket: null,
      startPk: -1,
    };
  },
  mounted() {
    EventBus.on('usernameAdded', (username) => {
      this.initializeSocket();
      this.username = username;
    });

    EventBus.on('usernameCleared', () => {
      this.messages = [];
      this.username = '';
    });

    const savedUsername = localStorage.getItem('username');
    if (savedUsername) {
      this.username = savedUsername;
      this.initializeSocket();
    }
  },
  methods: {
    showComponent() {
      return this.username !== '';
    },
    initializeSocket() {
      this.socket = getSocket();

      if (this.socket) {
        this.socket.on('chat message', (row) => {
          const pk = row.pk;

          // agregar al final de la lista
          this.messages.push(row);

          // siempre guardar el pk mas pequeño
          if (this.startPk === -1 || pk < this.startPk) {
            this.startPk = pk;
          }
        });

        this.socket.on('chat message error', (row) => {
          const content = `*** ${row.content} ***`;
          const atTheStart = row.atTheStart;

          const rTmp = {
            content
          }

          if (atTheStart) {
            this.messages.unshift(rTmp);
          } else {
            this.messages.push(rTmp);
          }
        });

        this.socket.on('chat message history', (row) => {
          const pk = row.pk;

          // siempre guardar el pk mas pequeño
          if (this.startPk === -1 || pk < this.startPk) {
            this.startPk = pk;
          }

          // agregar al inicio de la lista
          this.messages.unshift(row);
        });
      } else {
        console.error('Socket is not initialized');
      }
    },
    sendMessage() {
      if (!this.socket) {
        alert('Socket no conectado!. Primero agrega un username.');
        return;
      }

      const startPk = 0
      this.socket.emit('chat message', this.message, startPk, () => {
        this.message = '';
      });
    },
    loadHistory() {
      if (!this.socket) {
        alert('Socket no conectado!. Primero agrega un username.');
        return;
      }

      this.socket.emit('chat message history', this.startPk);
    },
    search() {
      if (!this.socket) {
        alert('Socket no conectado!. Primero agrega un username.');
        return;
      }

      if (!this.message) {
        alert('Please enter a search term.');
        return;
      }

      this.socket.emit('chat message search', this.message, this.startPk, () => {
        this.message = '';
      });
    },
    isActiveUser(username) {
      return this.username === username;
    },
    formatDate(dateString) {
      const options = { year: 'numeric', month: 'long', day: 'numeric', hour: '2-digit', minute: '2-digit', second: '2-digit' };
      return new Intl.DateTimeFormat('default', options).format(new Date(dateString));
    },
  },
};
</script>

<style scoped>
.chat {
  display: flex;
  flex-direction: column;
  height: 100%;
}

.static-row {
  background-color: transparent;
}

.me-row {
  text-align: right;
}

.messages {
  flex-grow: 1;
  overflow-y: auto;
  padding: 0 20px;
  background-color: rgb(53, 53, 53);
  color: white;
}

.input-container {
  display: flex;
  padding: 10px;
  background-color: rgb(14, 16, 15)
}

.input-container input {
  flex-grow: 1;
  margin-right: 10px;
}

.c-title {
  color: #00a2d7;
}

.size-xs {
  font-size: 0.8em;
}
</style>